Search documentation of wx

# View Source wxUpdateUIEvent (wx v2.4.2)

Functions for wxUpdateUIEvent class

This class is used for pseudo-events which are called by wxWidgets to give an application the chance to update various user interface elements.

Without update UI events, an application has to work hard to check/uncheck, enable/disable, show/hide, and set the text for elements such as menu items and toolbar buttons. The code for doing this has to be mixed up with the code that is invoked when an action is invoked for a menu item or button.

With update UI events, you define an event handler to look at the state of the application and change UI elements accordingly. wxWidgets will call your member functions in idle time, so you don't have to worry where to call this code.

In addition to being a clearer and more declarative method, it also means you don't have to worry whether you're updating a toolbar or menubar identifier. The same handler can update a menu item and toolbar button, if the identifier is the same. Instead of directly manipulating the menu or button, you call functions in the event object, such as `check/2`. wxWidgets will determine whether such a call has been made, and which UI element to update.

These events will work for popup menus as well as menubars. Just before a menu is popped up, `wxMenu::UpdateUI` (not implemented in wx) is called to process any UI events for the window that owns the menu.

If you find that the overhead of UI update processing is affecting your application, you can do one or both of the following:

Note that although events are sent in idle time, defining a `wxIdleEvent` handler for a window does not affect this because the events are sent from `wxWindow::OnInternalIdle` (not implemented in wx) which is always called in idle time.

wxWidgets tries to optimize update events on some platforms. On Windows and GTK+, events for menubar items are only sent when the menu is about to be shown, and not in idle time.

See: Overview events

This class is derived (and can use functions) from: `wxCommandEvent` `wxEvent`

wxWidgets docs: wxUpdateUIEvent

## Events

Use `wxEvtHandler:connect/3` with `wxUpdateUIEventType` to subscribe to events of this type.

# Summary

## Types

wxUpdateUI()
wxUpdateUIEvent()
wxUpdateUIEventType()

## Functions

canUpdate(Window)

Returns true if it is appropriate to update (send UI update events to) this window.

check(This, Check)

Check or uncheck the UI element.

enable(This, Enable)

Enable or disable the UI element.

getChecked(This)

Returns true if the UI element should be checked.

getEnabled(This)

Returns true if the UI element should be enabled.

getMode()

Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

getSetChecked(This)

Returns true if the application has called `check/2`.

getSetEnabled(This)

Returns true if the application has called `enable/2`.

getSetShown(This)

Returns true if the application has called `show/2`.

getSetText(This)

Returns true if the application has called `setText/2`.

getShown(This)

Returns true if the UI element should be shown.

getText(This)

Returns the text that should be set for the UI element.

getUpdateInterval()

Returns the current interval between updates in milliseconds.

resetUpdateTime()

Used internally to reset the last-updated time to the current time.

setMode(Mode)

Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

setText(This, Text)

Sets the text for this UI element.

setUpdateInterval(UpdateInterval)

Sets the interval between updates in milliseconds.

show(This, Show)

Show or hide the UI element.

# Types

Link to this type

# wxUpdateUI()

View Source

    -type wxUpdateUI() :: #wxUpdateUI{type :: wxUpdateUIEvent:wxUpdateUIEventType()}.

Link to this type

# wxUpdateUIEvent()

View Source

    -type wxUpdateUIEvent() :: wx:wx_object().

Link to this type

# wxUpdateUIEventType()

View Source

    -type wxUpdateUIEventType() :: update_ui.

# Functions

Link to this function

# canUpdate(Window)

View Source

    -spec canUpdate(Window) -> boolean() when Window :: wxWindow:wxWindow().

Returns true if it is appropriate to update (send UI update events to) this window.

This function looks at the mode used (see `setMode/1`), the wxWS_EX_PROCESS_UI_UPDATES flag in `window`, the time update events were last sent in idle time, and the update interval, to determine whether events should be sent to this window now. By default this will always return true because the update mode is initially wxUPDATE_UI_PROCESS_ALL and the interval is set to 0; so update events will be sent as often as possible. You can reduce the frequency that events are sent by changing the mode and/or setting an update interval.

See: `resetUpdateTime/0`, `setUpdateInterval/1`, `setMode/1`

Link to this function

# check(This, Check)

View Source

    -spec check(This, Check) -> ok when This :: wxUpdateUIEvent(), Check :: boolean().

Check or uncheck the UI element.

Link to this function

# enable(This, Enable)

View Source

    -spec enable(This, Enable) -> ok when This :: wxUpdateUIEvent(), Enable :: boolean().

Enable or disable the UI element.

Link to this function

# getChecked(This)

View Source

    -spec getChecked(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the UI element should be checked.

Link to this function

# getEnabled(This)

View Source

    -spec getEnabled(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the UI element should be enabled.

Link to this function

# getMode()

View Source

    -spec getMode() -> wx:wx_enum().

Static function returning a value specifying how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

See: `setMode/1`

Link to this function

# getSetChecked(This)

View Source

    -spec getSetChecked(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the application has called `check/2`.

For wxWidgets internal use only.

Link to this function

# getSetEnabled(This)

View Source

    -spec getSetEnabled(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the application has called `enable/2`.

For wxWidgets internal use only.

Link to this function

# getSetShown(This)

View Source

    -spec getSetShown(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the application has called `show/2`.

For wxWidgets internal use only.

Link to this function

# getSetText(This)

View Source

    -spec getSetText(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the application has called `setText/2`.

For wxWidgets internal use only.

Link to this function

# getShown(This)

View Source

    -spec getShown(This) -> boolean() when This :: wxUpdateUIEvent().

Returns true if the UI element should be shown.

Link to this function

# getText(This)

View Source

    -spec getText(This) -> unicode:charlist() when This :: wxUpdateUIEvent().

Returns the text that should be set for the UI element.

Link to this function

# getUpdateInterval()

View Source

    -spec getUpdateInterval() -> integer().

Returns the current interval between updates in milliseconds.

The value -1 disables updates, 0 updates as frequently as possible.

See: `setUpdateInterval/1`

Link to this function

# resetUpdateTime()

View Source

    -spec resetUpdateTime() -> ok.

Used internally to reset the last-updated time to the current time.

It is assumed that update events are normally sent in idle time, so this is called at the end of idle processing.

See: `canUpdate/1`, `setUpdateInterval/1`, `setMode/1`

Link to this function

# setMode(Mode)

View Source

    -spec setMode(Mode) -> ok when Mode :: wx:wx_enum().

Specify how wxWidgets will send update events: to all windows, or only to those which specify that they will process the events.

Link to this function

# setText(This, Text)

View Source

    -spec setText(This, Text) -> ok when This :: wxUpdateUIEvent(), Text :: unicode:chardata().

Sets the text for this UI element.

Link to this function

# setUpdateInterval(UpdateInterval)

View Source

    -spec setUpdateInterval(UpdateInterval) -> ok when UpdateInterval :: integer().

Sets the interval between updates in milliseconds.

Set to -1 to disable updates, or to 0 to update as frequently as possible. The default is 0.

Use this to reduce the overhead of UI update events if your application has a lot of windows. If you set the value to -1 or greater than 0, you may also need to call `wxWindow:updateWindowUI/2` at appropriate points in your application, such as when a dialog is about to be shown.

Link to this function

# show(This, Show)

View Source

    -spec show(This, Show) -> ok when This :: wxUpdateUIEvent(), Show :: boolean().

Show or hide the UI element.